//
//  GameData.m
//  Tonosamart
//
//  Created by Kansuke Nishida on 12/05/03.
//  Copyright (c) 2012年 tonosamart. All rights reserved.
//

#import "GameData.h"

@implementation GameData

static GameData* _gameDataInstance = nil;

+ (GameData*)getInstance{
	if(_gameDataInstance != nil){
		return _gameDataInstance;
	}else{
		_gameDataInstance = [[GameData alloc]init];
		return _gameDataInstance;
	}
}

- (id)init{
    if((self = [super init])){
        self.stickArrayL = [NSMutableArray array];
        self.stickArrayR = [NSMutableArray array];
        [self resetScore];
    }
	return self;
}

- (void)dealloc{
    [self.stickArrayL retain];
    [self.stickArrayR retain];
    [super dealloc];
}

-(void)resetStickArray{
    [self.stickArrayL removeAllObjects];
    [self.stickArrayR removeAllObjects];
}

-(void)resetScore{
    self.score = 0;
    self.exp = 0;
    self.level = 1;

    self.invaderScaleMin = 1.0f;
    self.invaderScaleMax = 1.0f;
    self.invaderDelayMax = 2.0f;
    self.invaderSpeed = 90;
}

-(void)addScore:(int)point{
    self.score += point;
    self.exp++;
    
    if(self.level < (self.exp / 10)){
        self.level++;
        self.invaderScaleMax += 0.3f;
        self.invaderDelayMax -= 0.25f;
        self.invaderSpeed += 5;
    }
}

#pragma mark public

@end