//
//  Invader.m
//
//  Created by tonosamart on 2012/09/06.
//  Copyright (c) 2012年 tonosamart. All rights reserved.
//

#import "Invader.h"
#import "GameData.h"
#import "TonoCocos.h"
#import "MainScene.h"

@implementation Invader

- (id)init{
    if((self = [super init])){
        self.sprite = [CCSprite spriteWithSpriteFrameName:@"vader.png"];
        GameData *gameData = [GameData getInstance];

        self.sprite.scale = (CCRANDOM_0_1() * (gameData.invaderScaleMax - gameData.invaderScaleMin)) + gameData.invaderScaleMin;
        
        self.minX = self.sprite.boundingBox.size.width / 2;
        self.maxX = 320 - (self.sprite.boundingBox.size.width / 2);

        float ex = (CCRANDOM_0_1() * (self.maxX - self.minX)) + self.minX;
        float ey = 568 + (self.sprite.boundingBox.size.height / 2);
        
        self.sprite.position = ccp(ex, ey);
        self.speed = gameData.invaderSpeed / self.sprite.scale / 3.0f;
        self.life = (int)(self.sprite.scale * MIN_LIFE);
        self.score = self.life;

        [self animeStart];
    }
	return self;
}

-(void)animeStart{
    [self.sprite stopAllActions];

    NSMutableArray *animFrames = [NSMutableArray array];
    [animFrames addObject:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:@"vader.png"]];
    [animFrames addObject:[[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:@"vader2.png"]];
    
    CCAnimation *animation = [CCAnimation animationWithSpriteFrames:animFrames delay:0.2f];
    id repeatAnim = [CCRepeatForever actionWithAction:[CCAnimate actionWithAnimation:animation]];
    [self.sprite runAction:repeatAnim];
}

-(void)dealloc{
    [super dealloc];
}

-(BOOL)damage:(int)pow{
    self.life -= pow;
    self.sprite.position = ccp(self.sprite.position.x, self.sprite.position.y + 32.0f);

    CCSpriteFrame *sf = [[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:@"vader_hit.png"];
    [self.sprite setDisplayFrame:sf];

    if(self.life <= 0){
        GameData *gameData = [GameData getInstance];
        [gameData addScore:self.score];
        return YES;
    }
    return NO;
}

-(BOOL)tick:(ccTime)dt{
    float x = self.sprite.position.x;
    float y = self.sprite.position.y - (self.speed * dt);
    self.sprite.position = ccp(x, y);
    
    // 侵略判定
    float dy = self.sprite.position.y - (self.sprite.boundingBox.size.height / 2);
    if(dy <= GAMEOVER_LINE){
        return YES;
    }
    
    return NO;
}

@end