//
//  TitleScene.m
//
//  Created by Kansuke Nishida on 12/07/25.
//  Copyright 2012年 tonosamart. All rights reserved.
//

#import "TitleScene.h"
#import "SimpleAudioEngine.h"
#import "TonoCocos.h"
#import "MainScene.h"

enum {
    LAYER_NULL,
    LAYER_BG,
    LAYER_TITLE,
    LAYER_FRONT
};

@implementation TitleScene

-(id)init{
    self = [super init];
    
    if (self) {
        self.bgLayer = [BgLayer node];
        [self addChild:self.bgLayer z:LAYER_BG tag:LAYER_BG];
        
        self.titleLayer = [TitleLayer node];
        [self addChild:self.titleLayer z:LAYER_TITLE tag:LAYER_TITLE];

        self.frontLayer = [FrontLayer node];
        [self addChild:self.frontLayer z:LAYER_FRONT tag:LAYER_FRONT];
    }
    
    return self;
}

- (void)onEnterTransitionDidFinish{
    [super onEnterTransitionDidFinish];
    [[SimpleAudioEngine sharedEngine] playBackgroundMusic:@"title.caf"];
    [self schedule:@selector(tick:)];
}

-(void)onEnter{
    [super onEnter];
}

-(void)tick:(ccTime)dt{
    if(self.titleLayer.isStart){
        self.titleLayer.isStart = NO;
        [[SimpleAudioEngine sharedEngine] stopBackgroundMusic];
        [[SimpleAudioEngine sharedEngine] playEffect:@"xstart.caf"];
        [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:1.0f scene:[MainScene node] withColor:ccBLACK]];
    }
}

@end
