//
//  TonoCocos.m
//  Tonosamart
//
//  Created by Kansuke Nishida on 12/05/03.
//  Copyright (c) 2012年 tonosamart. All rights reserved.
//

#import "TonoCocos.h"

@implementation TonoCocos

+(CGPoint)convertToGL:(CCLayer*)layer touchPoint:(CGPoint)touchPoint{
    CGPoint retPoint = [[CCDirector sharedDirector] convertToGL:touchPoint];
    retPoint = ccp(retPoint.x - layer.position.x, retPoint.y - layer.position.y);
    return retPoint;
}

+ (void)delSprite:(id)node{
    [node removeFromParentAndCleanup:YES];
}

+ (CGRect)rectForSprite:(CCSprite *)sprite{
	float w = sprite.contentSize.width * sprite.scaleX;
	float h = sprite.contentSize.height * sprite.scaleY;
	float x = sprite.position.x - (w * sprite.anchorPoint.x);
	float y = sprite.position.y - (h * sprite.anchorPoint.y);
    return CGRectMake(x, y, w, h);
}

+(UIImage*) screenshot
{
    CCNode *startNode = [[CCDirector sharedDirector] runningScene];
    
    [CCDirector sharedDirector].nextDeltaTimeZero = YES;
    
    CGSize winSize = [CCDirector sharedDirector].winSize;
    CCRenderTexture* rtx =
    [CCRenderTexture renderTextureWithWidth:winSize.width
                                     height:winSize.height];
    [rtx begin];
    [startNode visit];
    [rtx end];
    
    return [rtx getUIImage];
}

+(BOOL)isIphone5{
    CGSize winSize = [[CCDirector sharedDirector] winSize];
    return (winSize.height == 568);
}

@end